import { useReducer, useMemo } from 'react';
import useMountedState from '@s-ui/react-hooks/lib/useMountedState';
import { getInitialPinInputReducerState, pinInputReducer } from './reducer';

var usePinInputReducer = function usePinInputReducer(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      mask = _ref.mask,
      defaultValue = _ref.defaultValue,
      value = _ref.value;

  var isMounted = useMountedState();
  var isMountedState = isMounted();
  var initialState = useMemo(function () {
    return isMountedState ? initialState : getInitialPinInputReducerState({
      mask: mask,
      defaultValue: defaultValue,
      value: value
    });
  }, [isMountedState]);
  return useReducer(pinInputReducer, initialState);
};

export default usePinInputReducer;